searchNodes=[{"ref":"MerklePatriciaTree.DB.html","title":"MerklePatriciaTree.DB","type":"behaviour","doc":"Defines a general key-value storage to back and persist out Merkle Patricia Trie. This is generally LevelDB in the community, but for testing, we&#39;ll generally use :ets. We define a callback that can be implemented by a number of potential backends."},{"ref":"MerklePatriciaTree.DB.html#get/2","title":"MerklePatriciaTree.DB.get/2","type":"function","doc":"Retrieves a key from the database. Examples iex&gt; db = MerklePatriciaTree.Test.random_ets_db() iex&gt; MerklePatriciaTree.DB.get(db, &quot;name&quot;) :not_found iex&gt; db = MerklePatriciaTree.Test.random_ets_db() iex&gt; MerklePatriciaTree.DB.put!(db, &quot;name&quot;, &quot;bob&quot;) iex&gt; MerklePatriciaTree.DB.get(db, &quot;name&quot;) {:ok, &quot;bob&quot;}"},{"ref":"MerklePatriciaTree.DB.html#c:get/2","title":"MerklePatriciaTree.DB.get/2","type":"callback","doc":""},{"ref":"MerklePatriciaTree.DB.html#get!/2","title":"MerklePatriciaTree.DB.get!/2","type":"function","doc":"Retrieves a key from the database, but raises if that key does not exist. Examples iex&gt; db = MerklePatriciaTree.Test.random_ets_db() iex&gt; MerklePatriciaTree.DB.get!(db, &quot;name&quot;) ** (MerklePatriciaTree.DB.KeyNotFoundError) cannot find key `name` iex&gt; db = MerklePatriciaTree.Test.random_ets_db() iex&gt; MerklePatriciaTree.DB.put!(db, &quot;name&quot;, &quot;bob&quot;) iex&gt; MerklePatriciaTree.DB.get!(db, &quot;name&quot;) &quot;bob&quot;"},{"ref":"MerklePatriciaTree.DB.html#c:init/1","title":"MerklePatriciaTree.DB.init/1","type":"callback","doc":""},{"ref":"MerklePatriciaTree.DB.html#put!/3","title":"MerklePatriciaTree.DB.put!/3","type":"function","doc":"Stores a key in the database. Examples ## Examples iex&gt; db = MerklePatriciaTree.Test.random_ets_db() iex&gt; MerklePatriciaTree.DB.put!(db, &quot;name&quot;, &quot;bob&quot;) iex&gt; MerklePatriciaTree.DB.get(db, &quot;name&quot;) {:ok, &quot;bob&quot;} iex&gt; MerklePatriciaTree.DB.put!(db, &quot;name&quot;, &quot;tom&quot;) iex&gt; MerklePatriciaTree.DB.get(db, &quot;name&quot;) {:ok, &quot;tom&quot;}"},{"ref":"MerklePatriciaTree.DB.html#c:put!/3","title":"MerklePatriciaTree.DB.put!/3","type":"callback","doc":""},{"ref":"MerklePatriciaTree.DB.html#t:db/0","title":"MerklePatriciaTree.DB.db/0","type":"type","doc":""},{"ref":"MerklePatriciaTree.DB.html#t:db_name/0","title":"MerklePatriciaTree.DB.db_name/0","type":"type","doc":""},{"ref":"MerklePatriciaTree.DB.html#t:db_ref/0","title":"MerklePatriciaTree.DB.db_ref/0","type":"type","doc":""},{"ref":"MerklePatriciaTree.DB.html#t:t/0","title":"MerklePatriciaTree.DB.t/0","type":"type","doc":""},{"ref":"MerklePatriciaTree.DB.html#t:value/0","title":"MerklePatriciaTree.DB.value/0","type":"type","doc":""},{"ref":"MerklePatriciaTree.DB.ETS.html","title":"MerklePatriciaTree.DB.ETS","type":"module","doc":"Implementation of MerklePatriciaTree.DB which is backed by :ets."},{"ref":"MerklePatriciaTree.DB.ETS.html#get/2","title":"MerklePatriciaTree.DB.ETS.get/2","type":"function","doc":"Retrieves a key from the database."},{"ref":"MerklePatriciaTree.DB.ETS.html#init/1","title":"MerklePatriciaTree.DB.ETS.init/1","type":"function","doc":"Performs initialization for this db."},{"ref":"MerklePatriciaTree.DB.ETS.html#put!/3","title":"MerklePatriciaTree.DB.ETS.put!/3","type":"function","doc":"Stores a key in the database."},{"ref":"MerklePatriciaTree.DB.KeyNotFoundError.html","title":"MerklePatriciaTree.DB.KeyNotFoundError","type":"exception","doc":""},{"ref":"MerklePatriciaTree.DB.LevelDB.html","title":"MerklePatriciaTree.DB.LevelDB","type":"module","doc":"Implementation of MerklePatriciaTree.DB which is backed by leveldb."},{"ref":"MerklePatriciaTree.DB.LevelDB.html#get/2","title":"MerklePatriciaTree.DB.LevelDB.get/2","type":"function","doc":"Retrieves a key from the database."},{"ref":"MerklePatriciaTree.DB.LevelDB.html#init/1","title":"MerklePatriciaTree.DB.LevelDB.init/1","type":"function","doc":"Performs initialization for this db."},{"ref":"MerklePatriciaTree.DB.LevelDB.html#put!/3","title":"MerklePatriciaTree.DB.LevelDB.put!/3","type":"function","doc":"Stores a key in the database."},{"ref":"MerklePatriciaTree.ListHelper.html","title":"MerklePatriciaTree.ListHelper","type":"module","doc":"Helpers for navigating lists, specifically for finding shared prefixes and postfixes."},{"ref":"MerklePatriciaTree.ListHelper.html#get_postfix/2","title":"MerklePatriciaTree.ListHelper.get_postfix/2","type":"function","doc":"Returns the post of list A if starts with list B, otherwise nil Examples iex&gt; MerklePatriciaTree.ListHelper.get_postfix([1,2,3], [1,2]) [3] iex&gt; MerklePatriciaTree.ListHelper.get_postfix([1,2,3,4], [1,2]) [3,4] iex&gt; MerklePatriciaTree.ListHelper.get_postfix([1,2,3,4], [1]) [2,3,4] iex&gt; MerklePatriciaTree.ListHelper.get_postfix([1,2,3,4], [0,1]) nil iex&gt; MerklePatriciaTree.ListHelper.get_postfix([1,2,3,4], []) [1,2,3,4] iex&gt; MerklePatriciaTree.ListHelper.get_postfix([1,2], [1,2,3]) nil iex&gt; MerklePatriciaTree.ListHelper.get_postfix([], []) []"},{"ref":"MerklePatriciaTree.ListHelper.html#overlap/2","title":"MerklePatriciaTree.ListHelper.overlap/2","type":"function","doc":"Returns the overlap of two lists in terms of a shared prefix, then the relative postfixes Examples iex&gt; MerklePatriciaTree.ListHelper.overlap([1,2,3], [1,2]) {[1,2],[3],[]} iex&gt; MerklePatriciaTree.ListHelper.overlap([1,2,3], [1,2,3,4]) {[1,2,3],[],[4]} iex&gt; MerklePatriciaTree.ListHelper.overlap([1,2,3], [2,3,4]) {[],[1,2,3],[2,3,4]} iex&gt; MerklePatriciaTree.ListHelper.overlap([], [2,3,4]) {[],[],[2,3,4]} iex&gt; MerklePatriciaTree.ListHelper.overlap([1,2,3], []) {[],[1,2,3],[]} iex&gt; MerklePatriciaTree.ListHelper.overlap([15, 10, 5, 11], [15, 11, 1, 14]) {[15], [10, 5, 11], [11, 1, 14]}"},{"ref":"MerklePatriciaTree.Test.html","title":"MerklePatriciaTree.Test","type":"module","doc":"Helper functions related to creating a MerklePatriciaTree database in :ets or :leveldb. This is to be used when you need to have a persisted table for a test case, which is basically any test that involves these tables. The tables generated by this module are supposed to be exceedingly temporary."},{"ref":"MerklePatriciaTree.Test.html#random_atom/1","title":"MerklePatriciaTree.Test.random_atom/1","type":"function","doc":"Returns a semi-random atom, similar to random_string/1, but is an atom. This is obviously not to be used in production since atoms are not garbage collected. Examples iex&gt; MerklePatriciaTree.Test.random_atom(20) |&gt; is_atom true iex&gt; MerklePatriciaTree.Test.random_atom(20) |&gt; Atom.to_string |&gt; String.length 20 iex&gt; MerklePatriciaTree.Test.random_atom(20) == MerklePatriciaTree.Test.random_atom(20) false"},{"ref":"MerklePatriciaTree.Test.html#random_ets_db/1","title":"MerklePatriciaTree.Test.random_ets_db/1","type":"function","doc":"Returns a random :ets database suitable for testing Examples iex&gt; {MerklePatriciaTree.DB.ETS, db_ref} = MerklePatriciaTree.Test.random_ets_db() iex&gt; :ets.info(db_ref)[:type] :set iex&gt; {MerklePatriciaTree.DB.ETS, db_ref} = MerklePatriciaTree.Test.random_ets_db(:test1) iex&gt; :ets.info(db_ref)[:name] :test1"},{"ref":"MerklePatriciaTree.Test.html#random_string/1","title":"MerklePatriciaTree.Test.random_string/1","type":"function","doc":"Returns a semi-random string of length length that can be represented by alphanumeric characters. Adopted from https://stackoverflow.com/a/32002566. Examples iex&gt; MerklePatriciaTree.Test.random_string(20) |&gt; is_binary true iex&gt; String.length(MerklePatriciaTree.Test.random_string(20)) 20 iex&gt; MerklePatriciaTree.Test.random_string(20) == MerklePatriciaTree.Test.random_string(20) false"},{"ref":"MerklePatriciaTree.Trie.html","title":"MerklePatriciaTree.Trie","type":"module","doc":"MerklePatriciaTree Elixir implementation of Ethereum&#39;s Merkle Patricia Tries. The encoding&#39;s specification can be found in the yellow paper or in the ethereum wiki under Appendix D. The modified patricia merkle trie allows arbitrary storage of key, value pairs with the benefits of a merkle trie in O(n*log(n)) time for insert, lookup and delete. This diagram is also very helpful in understanding these tries. Installation The easiest way to add MerklePatriciaTree to your project is by using Mix. Add :merkle_patricia_tree as a dependency to your project&#39;s mix.exs: defp deps do [ {:merkle_patricia_tree, &quot;~&gt; 0.2.8&quot;} ] end And run: $ mix deps.get Basic Usage Use the MerklePatriciaTree module to create and build merkle patricia tries. You will be required to choose a storage database, and we currently support :ets and :leveldb. The follow example illustrates how to create an update a trie. ## Examples iex&gt; trie = ...&gt; MerklePatriciaTree.Test.random_ets_db() ...&gt; |&gt; MerklePatriciaTree.Trie.new() ...&gt; |&gt; MerklePatriciaTree.Trie.update(&lt;&lt;0x01::4, 0x02::4&gt;&gt;, &quot;wee&quot;) ...&gt; |&gt; MerklePatriciaTree.Trie.update(&lt;&lt;0x01::4, 0x02::4, 0x03::4&gt;&gt;, &quot;cool&quot;) iex&gt; trie_2 = MerklePatriciaTree.Trie.update(trie, &lt;&lt;0x01::4, 0x02::4, 0x03::4&gt;&gt;, &quot;cooler&quot;) iex&gt; MerklePatriciaTree.Trie.get(trie, &lt;&lt;0x01::4, 0x02::4, 0x03::4&gt;&gt;) &quot;cool&quot; iex&gt; MerklePatriciaTree.Trie.get(trie_2, &lt;&lt;0x01::4&gt;&gt;) nil iex&gt; MerklePatriciaTree.Trie.get(trie_2, &lt;&lt;0x01::4, 0x02::4&gt;&gt;) &quot;wee&quot; iex&gt; MerklePatriciaTree.Trie.get(trie_2, &lt;&lt;0x01::4, 0x02::4, 0x03::4&gt;&gt;) &quot;cooler&quot; iex&gt; MerklePatriciaTree.Trie.get(trie_2, &lt;&lt;0x01::4, 0x02::4, 0x03::4, 0x04::4&gt;&gt;) nil Contributing Fork it! Create your feature branch (git checkout -b my-new-feature) Commit your changes (git commit -am &#39;Add some feature&#39;) Push to the branch (git push origin my-new-feature) Create new Pull Request Author Geoffrey Hayes (@hayesgm) Ayrat Badykov (@ayrat555) License MerklePatriciaTree is released under the MIT License. See the LICENSE file for further details."},{"ref":"MerklePatriciaTree.Trie.html#empty_trie_root_hash/0","title":"MerklePatriciaTree.Trie.empty_trie_root_hash/0","type":"function","doc":"Returns the canonical empty trie. Note: this root hash will not be accessible unless you have stored the result in a db. If you are initializing a new trie, instead of checking a result is empty, it&#39;s strongly recommended you use Trie.new(db).root_hash. Examples iex&gt; MerklePatriciaTree.Trie.empty_trie_root_hash() &lt;&lt;86, 232, 31, 23, 27, 204, 85, 166, 255, 131, 69, 230, 146, 192, 248, 110, 91, 72, 224, 27, 153, 108, 173, 192, 1, 98, 47, 181, 227, 99, 180, 33&gt;&gt;"},{"ref":"MerklePatriciaTree.Trie.html#get/2","title":"MerklePatriciaTree.Trie.get/2","type":"function","doc":"Given a trie, returns the value associated with key."},{"ref":"MerklePatriciaTree.Trie.html#into/2","title":"MerklePatriciaTree.Trie.into/2","type":"function","doc":"Moves trie down to be rooted at next_node, this is effectively (and literally) just changing the root_hash to node_hash."},{"ref":"MerklePatriciaTree.Trie.html#new/2","title":"MerklePatriciaTree.Trie.new/2","type":"function","doc":"Contructs a new unitialized trie. Examples iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db(:trie_test_1)) %MerklePatriciaTree.Trie{db: {MerklePatriciaTree.DB.ETS, :trie_test_1}, root_hash: &lt;&gt;} iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db(:trie_test_2), &lt;&gt;) %MerklePatriciaTree.Trie{db: {MerklePatriciaTree.DB.ETS, :trie_test_2}, root_hash: &lt;&gt;} iex&gt; trie = MerklePatriciaTree.Trie.new(MerklePatriciaTree.DB.LevelDB.init(&quot;/tmp/Sgt4V05yvi2BrhaBCZ9a&quot;), &lt;&gt;) iex&gt; trie.root_hash &lt;&lt;241, 136, 94, 218, 84, 183, 160, 83, 49, 140, 212, 30, 32, 147, 34, 13, 171, 21, 214, 83, 129, 177, 21, 122, 54, 51, 168, 59, 253, 92, 146, 57&gt;&gt; iex&gt; {db, _db_ref} = trie.db iex&gt; db MerklePatriciaTree.DB.LevelDB"},{"ref":"MerklePatriciaTree.Trie.html#store/1","title":"MerklePatriciaTree.Trie.store/1","type":"function","doc":""},{"ref":"MerklePatriciaTree.Trie.html#update/3","title":"MerklePatriciaTree.Trie.update/3","type":"function","doc":"Updates a trie by setting key equal to value. If value is nil, we will instead remove key from the trie."},{"ref":"MerklePatriciaTree.Trie.html#t:key/0","title":"MerklePatriciaTree.Trie.key/0","type":"type","doc":""},{"ref":"MerklePatriciaTree.Trie.html#t:root_hash/0","title":"MerklePatriciaTree.Trie.root_hash/0","type":"type","doc":""},{"ref":"MerklePatriciaTree.Trie.html#t:t/0","title":"MerklePatriciaTree.Trie.t/0","type":"type","doc":""},{"ref":"MerklePatriciaTree.Trie.Builder.html","title":"MerklePatriciaTree.Trie.Builder","type":"module","doc":"Builder is responsible for adding keys to an existing merkle trie. To add a key, we need to make a delta to our trie that ends up as the canonical form of the given tree as defined in http://gavwood.com/Paper.pdf. Note: this algorithm is non-obvious, and hence why we have a good number of functional and invariant tests. We should add more specific unit tests to this module."},{"ref":"MerklePatriciaTree.Trie.Builder.html#put_key/4","title":"MerklePatriciaTree.Trie.Builder.put_key/4","type":"function","doc":"Adds a key-value pair to a given trie. This may radically change the structure of the trie."},{"ref":"MerklePatriciaTree.Trie.Destroyer.html","title":"MerklePatriciaTree.Trie.Destroyer","type":"module","doc":"Destroyer is responsible for removing keys from a merkle trie. To remove a key, we need to make a delta to our trie which ends up as the canonical form of the given tree as defined in http://gavwood.com/Paper.pdf. Note: this algorithm is non-obvious, and hence why we have a good number of functional and invariant tests. We should add more specific unit tests to this module."},{"ref":"MerklePatriciaTree.Trie.Destroyer.html#remove_key/3","title":"MerklePatriciaTree.Trie.Destroyer.remove_key/3","type":"function","doc":"Removes a key from a given trie, if it exists. This may radically change the structure of the trie."},{"ref":"MerklePatriciaTree.Trie.Helper.html","title":"MerklePatriciaTree.Trie.Helper","type":"module","doc":"Functions to help with manipulating or working with tries."},{"ref":"MerklePatriciaTree.Trie.Helper.html#get_binary/1","title":"MerklePatriciaTree.Trie.Helper.get_binary/1","type":"function","doc":"Returns the binary of a given a list of nibbles Examples iex&gt; MerklePatriciaTree.Trie.Helper.get_binary([0x01, 0x0e, 0x02, 0x0f]) &lt;&gt; iex&gt; MerklePatriciaTree.Trie.Helper.get_binary([1, 2, 3]) &lt;&gt; iex&gt; MerklePatriciaTree.Trie.Helper.get_binary([0, 1, 0, 2, 0, 3]) &lt;&gt;"},{"ref":"MerklePatriciaTree.Trie.Helper.html#get_nibbles/1","title":"MerklePatriciaTree.Trie.Helper.get_nibbles/1","type":"function","doc":"Returns the nibbles of a given binary as a list Examples iex&gt; MerklePatriciaTree.Trie.Helper.get_nibbles(&lt;&gt;) [0x01, 0x0e, 0x02, 0x0f] iex&gt; MerklePatriciaTree.Trie.Helper.get_nibbles(&lt;&gt;) [1, 2, 3] iex&gt; MerklePatriciaTree.Trie.Helper.get_nibbles(&lt;&gt;) [0, 1, 0, 2, 0, 3]"},{"ref":"MerklePatriciaTree.Trie.Inspector.html","title":"MerklePatriciaTree.Trie.Inspector","type":"module","doc":"A simple module to inspect and print the structure of tries."},{"ref":"MerklePatriciaTree.Trie.Inspector.html#all_keys/1","title":"MerklePatriciaTree.Trie.Inspector.all_keys/1","type":"function","doc":"Returns all keys from a trie. Note: this simply calls all_values/1 and returns the first value of all tuples. Examples iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db()) ...&gt; |&gt; MerklePatriciaTree.Trie.update(&quot;type&quot;, &quot;fighter&quot;) ...&gt; |&gt; MerklePatriciaTree.Trie.update(&quot;name&quot;, &quot;bob&quot;) ...&gt; |&gt; MerklePatriciaTree.Trie.update(&quot;nationality&quot;, &quot;usa&quot;) ...&gt; |&gt; MerklePatriciaTree.Trie.update(&quot;nato&quot;, &quot;strong&quot;) ...&gt; |&gt; MerklePatriciaTree.Trie.update((for x &lt;- 1..100, into: &lt;&lt;&gt;&gt;, do: &lt;&lt;x::8&gt;&gt;), (for x &lt;- 1..100, into: &lt;&lt;&gt;&gt;, do: &lt;&lt;x*2::8&gt;&gt;)) ...&gt; |&gt; MerklePatriciaTree.Trie.Inspector.all_keys() [ (for x &lt;- 1..100, into: &lt;&lt;&gt;&gt;, do: &lt;&lt;x::8&gt;&gt;), &quot;name&quot;, &quot;nationality&quot;, &quot;nato&quot;, &quot;type&quot;, ]"},{"ref":"MerklePatriciaTree.Trie.Inspector.html#all_values/1","title":"MerklePatriciaTree.Trie.Inspector.all_values/1","type":"function","doc":"Returns all values from a trie. Examples iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db()) ...&gt; |&gt; MerklePatriciaTree.Trie.update(&quot;type&quot;, &quot;fighter&quot;) ...&gt; |&gt; MerklePatriciaTree.Trie.update(&quot;name&quot;, &quot;bob&quot;) ...&gt; |&gt; MerklePatriciaTree.Trie.update(&quot;nationality&quot;, &quot;usa&quot;) ...&gt; |&gt; MerklePatriciaTree.Trie.update(&quot;nato&quot;, &quot;strong&quot;) ...&gt; |&gt; MerklePatriciaTree.Trie.update((for x &lt;- 1..100, into: &lt;&lt;&gt;&gt;, do: &lt;&lt;x::8&gt;&gt;), (for x &lt;- 1..100, into: &lt;&lt;&gt;&gt;, do: &lt;&lt;x*2::8&gt;&gt;)) ...&gt; |&gt; MerklePatriciaTree.Trie.Inspector.all_values() [ {(for x &lt;- 1..100, into: &lt;&lt;&gt;&gt;, do: &lt;&lt;x::8&gt;&gt;), (for x &lt;- 1..100, into: &lt;&lt;&gt;&gt;, do: &lt;&lt;x*2::8&gt;&gt;)}, {&quot;name&quot;, &quot;bob&quot;}, {&quot;nationality&quot;, &quot;usa&quot;}, {&quot;nato&quot;, &quot;strong&quot;}, {&quot;type&quot;, &quot;fighter&quot;}, ]"},{"ref":"MerklePatriciaTree.Trie.Inspector.html#inspect/2","title":"MerklePatriciaTree.Trie.Inspector.inspect/2","type":"function","doc":"Helper function to print an instruction message."},{"ref":"MerklePatriciaTree.Trie.Inspector.html#inspect_trie/1","title":"MerklePatriciaTree.Trie.Inspector.inspect_trie/1","type":"function","doc":"Prints a visual depiction of a trie, returns trie itself. TODO: Test, possibly."},{"ref":"MerklePatriciaTree.Trie.Node.html","title":"MerklePatriciaTree.Trie.Node","type":"module","doc":"This module encodes and decodes nodes from a trie encoding back into RLP form. We effectively implement c(I, i) from the Yellow Paper. TODO: Add richer set of tests, esp. in re: storage and branch values."},{"ref":"MerklePatriciaTree.Trie.Node.html#decode_trie/1","title":"MerklePatriciaTree.Trie.Node.decode_trie/1","type":"function","doc":"Decodes the root of a given trie, effectively inverting the encoding from c(I, i) defined in Eq.(179) fo the Yellow Paper. Examples iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db(), &lt;&gt;) iex&gt; |&gt; MerklePatriciaTree.Trie.Node.decode_trie() :empty iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db(), &lt;&gt;) iex&gt; |&gt; MerklePatriciaTree.Trie.Node.decode_trie() iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db(), &lt;&gt;) iex&gt; |&gt; MerklePatriciaTree.Trie.Node.decode_trie() iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db(), &lt;&gt;) iex&gt; |&gt; MerklePatriciaTree.Trie.Node.decode_trie()"},{"ref":"MerklePatriciaTree.Trie.Node.html#encode_node/2","title":"MerklePatriciaTree.Trie.Node.encode_node/2","type":"function","doc":"Given a node, this function will encode the node and put the value to storage (for nodes that are greater than 32 bytes encoded). This implements c(I, i), Eq.(179) of the Yellow Paper. Examples iex&gt; trie = MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db()) iex&gt; MerklePatriciaTree.Trie.Node.encode_node(:empty, trie) &lt;&lt;&gt;&gt; iex&gt; trie = MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db()) iex&gt; MerklePatriciaTree.Trie.Node.encode_node({:leaf, [5,6,7], &quot;ok&quot;}, trie) [&quot;5g&quot;, &quot;ok&quot;] iex&gt; trie = MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db()) iex&gt; MerklePatriciaTree.Trie.Node.encode_node({:branch, [&lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;, &lt;&lt;&gt;&gt;]}, trie) [&quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;, &quot;&quot;] iex&gt; trie = MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db()) iex&gt; MerklePatriciaTree.Trie.Node.encode_node({:ext, [1, 2, 3], &lt;&lt;&gt;&gt;}, trie) [&lt;&gt;, &quot;&quot;]"},{"ref":"MerklePatriciaTree.Trie.Node.html#t:trie_node/0","title":"MerklePatriciaTree.Trie.Node.trie_node/0","type":"type","doc":""},{"ref":"MerklePatriciaTree.Trie.Storage.html","title":"MerklePatriciaTree.Trie.Storage","type":"module","doc":"Module to get and put nodes in a trie by the given storage mechanism. Generally, handles the function n(I, i), Eq.(178) from the Yellow Paper."},{"ref":"MerklePatriciaTree.Trie.Storage.html#get_node/1","title":"MerklePatriciaTree.Trie.Storage.get_node/1","type":"function","doc":"Gets the RLP encoded value of a given trie root. Specifically, we invert the function n(I, i) Eq.(178) from the Yellow Paper. Examples iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db(), &lt;&lt;&gt;&gt;) ...&gt; |&gt; MerklePatriciaTree.Trie.Storage.get_node() &lt;&lt;&gt;&gt; iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db(), &lt;&gt;) ...&gt; |&gt; MerklePatriciaTree.Trie.Storage.get_node() &quot;Hi&quot; iex&gt; MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db(), &lt;&gt;) ...&gt; |&gt; MerklePatriciaTree.Trie.Storage.get_node() :not_found iex&gt; trie = MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db(), &lt;&gt;) iex&gt; MerklePatriciaTree.Trie.Storage.put_node([&quot;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA&quot;], trie) &lt;&lt;141, 163, 93, 242, 120, 27, 128, 97, 138, 56, 116, 101, 165, 201, 165, 139, 86, 73, 85, 153, 45, 38, 207, 186, 196, 202, 111, 84, 214, 26, 122, 164&gt;&gt; iex&gt; MerklePatriciaTree.Trie.Storage.get_node(%{trie| root_hash: &lt;&gt;}) [&quot;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA&quot;]"},{"ref":"MerklePatriciaTree.Trie.Storage.html#max_rlp_len/0","title":"MerklePatriciaTree.Trie.Storage.max_rlp_len/0","type":"function","doc":""},{"ref":"MerklePatriciaTree.Trie.Storage.html#put_node/2","title":"MerklePatriciaTree.Trie.Storage.put_node/2","type":"function","doc":"Takes an RLP-encoded node and pushes it to storage, as defined by n(I, i) Eq.(178) of the Yellow Paper. NOTA BENE: we are forced to deviate from the Yellow Paper as nodes which are smaller than 32 bytes aren&#39;t encoded in RLP, as suggested by the equations. Specifically, Eq.(178) says that the node is encoded as c(J,i) in the second portion of the definition of n. By the definition of c, all return values are RLP encoded. But, we have found emperically that the n does not encode values to RLP for smaller nodes. Examples iex&gt; trie = MerklePatriciaTree.Trie.new(MerklePatriciaTree.Test.random_ets_db()) iex&gt; MerklePatriciaTree.Trie.Storage.put_node(&lt;&lt;&gt;&gt;, trie) &lt;&lt;&gt;&gt; iex&gt; MerklePatriciaTree.Trie.Storage.put_node(&quot;Hi&quot;, trie) &quot;Hi&quot; iex&gt; MerklePatriciaTree.Trie.Storage.put_node([&quot;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA&quot;], trie) &lt;&lt;141, 163, 93, 242, 120, 27, 128, 97, 138, 56, 116, 101, 165, 201, 165, 139, 86, 73, 85, 153, 45, 38, 207, 186, 196, 202, 111, 84, 214, 26, 122, 164&gt;&gt;"},{"ref":"MerklePatriciaTree.Trie.Storage.html#store/2","title":"MerklePatriciaTree.Trie.Storage.store/2","type":"function","doc":"TODO: Doc and test"},{"ref":"MerklePatriciaTree.Trie.Verifier.html","title":"MerklePatriciaTree.Trie.Verifier","type":"module","doc":"Function to verify the structure of a trie meets the spec as defined in http://gavwood.com/Paper.pdf."},{"ref":"MerklePatriciaTree.Trie.Verifier.html#verify_trie/2","title":"MerklePatriciaTree.Trie.Verifier.verify_trie/2","type":"function","doc":"Runs simple tests to verify a trie matches general specs. We will check: Leafs have a non-empty value Leafs&#39; and branch&#39;s value belong to a set of given values. Branches have at least two non-empty nodes. All sub-tries are valid. Ext&#39;s prefixes aren&#39;t blank. TODO: Ext&#39;s can&#39;t be extended."}]